# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class ChecksumAlgorithm(str, enum.Enum):
    """
    Algorithm of the checksum for integrity check.
    """

    CRC_32 = "CRC32"
    CRC_32_C = "CRC32C"
    SHA_1 = "SHA1"
    SHA_256 = "SHA256"

    def visit(
        self,
        crc_32: typing.Callable[[], T_Result],
        crc_32_c: typing.Callable[[], T_Result],
        sha_1: typing.Callable[[], T_Result],
        sha_256: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is ChecksumAlgorithm.CRC_32:
            return crc_32()
        if self is ChecksumAlgorithm.CRC_32_C:
            return crc_32_c()
        if self is ChecksumAlgorithm.SHA_1:
            return sha_1()
        if self is ChecksumAlgorithm.SHA_256:
            return sha_256()
